<?
  include_once(dirname(__FILE__) ."/include/main.php");
  $errors = array();

  
  if(Helper::IsLoggedInAdmin() && $_GET["loginAsUser"])
  {
    // login as a certain user and redirect to his page
    if(Helper::LoginUserByUsername($_GET["loginAsUser"]))
    {
      Helper::Redirect("index.php?". Helper::CreateQuerystring(getUser()));
    }
  }
  
  $users = DataAccess::GetAllUsers(!Helper::IsLoggedInAdmin());
  
  $lastMapForEachUser = DataAccess::GetLastMapsForUsers();
  
  // last 20 maps
  $lastMaps = DataAccess::GetMaps(0, 0, 0, 0, 20, "lastChangedTime");


  if($_GET["error"] == "email") $errors[] = sprintf(__("ADMIN_EMAIL_ERROR"), ADMIN_EMAIL);

?>
<?php print '<?xml version="1.0" encoding="UTF-8"?>'; ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <title><?=_SITE_TITLE?></title>
  <meta http-equiv="Content-Type" content="text/html;charset=UTF-8" />
  <link rel="stylesheet" href="style.css" type="text/css" />
  <link rel="icon" type="image/png" href="gfx/favicon.png" />
  <link rel="alternate" type="application/rss+xml" title="RSS" href="rss.php" />
  <script type="text/javascript" src="js/prototype/prototype_1.6.0.3.js"></script>
  <script type="text/javascript">
    function showThumbnail(id, type, visible)
    {
      if(visible)
      {
        $('hoverThumbnail_' + type + "_" + id).removeClassName('hidden');
      }
      else
      {
        $('hoverThumbnail_' + type + "_" + id).addClassName('hidden');
      }
    }
  </script>
</head>

<body id="usersBody">
<div id="wrapper">
<? Helper::CreateUserListTopbar(); ?>
<div id="content">
<form method="post" action="<?=$PHP_SELF?>">

<div id="rssIcon"><a href="rss.php"><img src="gfx/feed-icon-28x28.png" alt="<?=__("RSS_FEED")?>" title="<?=__("RSS_FEED")?>" /></a></div>

<h1><?=_SITE_TITLE?></h1>

<?
  if(count($errors) > 0)
  {
  ?>
    <ul class="error">
    <?
      foreach($errors as $e)
      {
        print "<li>$e</li>";
      }
    ?>
    </ul>  
  <?  
  }
?>

<p><?=_SITE_DESCRIPTION?></p>

<?
  if(count($users) == 0)
  {
    print '<p>'. __("NO_USERS_CREATED");
    if(Helper::IsLoggedInAdmin()) print ' <a href="edit_user.php?mode=admin">'. __("CREATE_THE_FIRST_USER") .'</a>';
    print '</p>';
  }
  
  if(!Helper::IsLoggedInAdmin() && PUBLIC_USER_CREATION_CODE) print '<p>'. __("PUBLIC_CREATE_USER_INFO") .'</p>';

  if(count($users) > 0)
  {
?>
<h2><?=__("USERS")?></h2>      
<table class="fullWidth">
<thead>
  <tr>
    <? if(Helper::IsLoggedInAdmin()) { ?>
    <th><?=__("USERNAME")?></th>
    <? } ?>
    <th><?=__("NAME")?></th>
    <th><?=__("NO_OF_MAPS")?></th>
    <th><?=__("LAST_MAP")?></th>
    <th><?=__("DATE")?></th>
    <th><?=__("UPDATED")?></th>
    <? if(Helper::IsLoggedInAdmin()) { ?>
    <th><?=__("VISIBLE")?></th>
    <th><?=__("EDIT")?></th>
    <th><?=__("LOGIN_AS")?></th>
    <? } ?>
  </tr>
</thead>
<tbody>
<?
  foreach($users as $u)
  {
    $count++;
    $lastMapLink = "";
    $lastMapDate = "";
    $lastMapUpdated = "";
    $loginAsUserLink = "";
    $thumbnailImage = "";
    $url = ($u->Visible ? "index.php?". Helper::CreateQuerystring($u) : "");
    $nameLink = Helper::EncapsulateLink(hsc($u->FirstName ." ". $u->LastName), $url);    

    $lastMap = $lastMapForEachUser[$u->ID];
    if($lastMap) 
    {
      $lastMapLink = '<a href="show_map.php?'. Helper::CreateQuerystring($u, $lastMap->ID) .'" onmouseover="showThumbnail('. $lastMap->ID .', \'users\', true);" onmouseout="showThumbnail('. $lastMap->ID .', \'users\', false);">'. 
                     hsc($lastMap->Name).
                     '</a>'; 

      $lastMapDate = date(__("DATE_FORMAT"), strtotime($lastMap->Date));
      $lastMapUpdated = date(__("DATETIME_FORMAT"), strtotime($lastMap->LastChangedTime));
      $thumbnailImage = '<img src="'. Helper::GetThumbnailImage($lastMap) .'" alt="'. hsc($lastMap->Name)  .'" height="'. THUMBNAIL_HEIGHT .'" width="'. THUMBNAIL_WIDTH .'" />';
    }
    
    $url = ($u->Visible ? "users.php?loginAsUser=". urlencode($u->Username) : "");
    $loginAsUserLink = Helper::EncapsulateLink(sprintf(__("LOGIN_AS_X"), hsc($u->FirstName)), $url);
    
    ?>
    <tr class="<?=($count % 2 == 1 ? "odd" : "even")?>">
      <? if(Helper::IsLoggedInAdmin()) { ?>
      <td><?=hsc($u->Username)?></td>
      <? } ?>
      <td><?=$nameLink?></td>
      <td><?=$u->NoOfMaps?></td>
      <td>
        <span class="hoverThumbnailContainer">
          <span class="hoverThumbnail hidden" id="hoverThumbnail_users_<?=$lastMap->ID?>">
            <?=$thumbnailImage?>
          </span>
        </span>
        <?=$lastMapLink?>
      </td>
      <td><?=$lastMapDate?></td>
      <td><?=$lastMapUpdated?></td>
      <? if(Helper::IsLoggedInAdmin()) { ?>
      <td><?=($u->Visible ? __("YES") : __("NO"))?></td>
      <td><a href="edit_user.php?mode=admin&amp;<?=Helper::CreateQuerystring($u)?>"><?=__("EDIT")?></a></td>
      <td><?=$loginAsUserLink?></td>
      
      <? } ?>
    </tr>
    <?  
    }
  ?>
</tbody>
</table>
<?
    if(count($lastMaps) > 0)
    {
      ?>
<h2><?=__("LAST_MAPS")?></h2>      
<table class="fullWidth">
<thead>
  <tr>
    <th><?=__("NAME")?></th>
    <th><?=__("MAP")?></th>
    <th><?=__("DATE")?></th>
    <th><?=__("CATEGORY")?></th>
    <th><?=__("UPDATED")?></th>
  </tr>
</thead>
<tbody>
      <?
      $count = 0;
      foreach($lastMaps as $map)
      {
        $count++;
        $url = "index.php?". Helper::CreateQuerystring($map->GetUser());
        $nameLink = Helper::EncapsulateLink(hsc($map->GetUser()->FirstName ." ". $map->GetUser()->LastName), $url);    
        $mapLink = '<a href="show_map.php?'. Helper::CreateQuerystring($map->GetUser(), $map->ID) .'" onmouseover="showThumbnail('. $map->ID .', \'lastMaps\', true);" onmouseout="showThumbnail('. $map->ID .', \'lastMaps\', false);">'. 
                   hsc($map->Name).
                   '</a>'; 
        
        $date = date(__("DATE_FORMAT"), strtotime($map->Date));
        $updated = date(__("DATETIME_FORMAT"), strtotime($map->LastChangedTime));

        $thumbnailImage = '<img src="'. Helper::GetThumbnailImage($map) .'" alt="'. hsc($map->Name)  .'" height="'. THUMBNAIL_HEIGHT .'" width="'. THUMBNAIL_WIDTH .'" />';
        
        ?>
        <tr class="<?=($count % 2 == 1 ? "odd" : "even")?>">
          <td><?=$nameLink?></td>
          <td>
            <span class="hoverThumbnailContainer">
              <span class="hoverThumbnail hidden" id="hoverThumbnail_lastMaps_<?=$map->ID?>">
                <?=$thumbnailImage?>
              </span>
            </span>
            <?=$mapLink?>
          </td>
          <td><?=$date?></td>
          <td><?=$map->getCategory()->Name?></td>
          <td><?=$updated?></td>
        </tr>
        <?          
      }
    }
    ?>
</tbody>
</table>
    <?
  }
?>
</form>
</div>
</div>
</body>
</html>